module incenc
  #(
    parameter PRE= 100
    )
   (
    input wire	clk,
    input wire	en,
    input wire	up,
    output wire	a,
    output wire	b
    );
   
   reg [31:0]	pre_cnt= 0;
   reg [1:0]	state= 0;

   wire		pre_end= pre_cnt == PRE;
   
   always @(posedge clk)
     if (pre_end | ~en)
       pre_cnt<= 0;
     else
       pre_cnt<= pre_cnt+1;
   
   always @(posedge clk)
     begin
	if (en & pre_end)
	  begin
	     if (up)
	       begin
		  case (state)
		    0: state<= 2;
		    1: state<= 0;
		    2: state<= 3;
		    3: state<= 1;
		  endcase;
	       end
	     else
	       begin
		  case (state)
		    0: state<= 1;
		    1: state<= 3;
		    2: state<= 0;
		    3: state<= 2;
		  endcase;
	       end
	  end
     end

   assign {b,a}= state;
   
endmodule
