`timescale 1ns / 1ps

module pmod_dsp
  (
   input [31:0] din0,
   input [31:0] din1,
   input 	clk,
   output [3:0] digit_value,
   output [3:0] digit_nr
   );
   
   reg [3:0] 	cnt= 0;

   always @(posedge clk)
     cnt<= cnt+1;
        
   wire [2:0] 	s;
   wire [3:0] 	d;
   wire [31:0] 	din;
   
   assign s= cnt[2:0];
   assign din= cnt[3]?din1:din0;
   
   assign d=
            (s==3'd0)?din[ 3: 0]:
            (s==3'd1)?din[ 7: 4]:
            (s==3'd2)?din[11: 8]:
            (s==3'd3)?din[15:12]:
            (s==3'd4)?din[19:16]:
            (s==3'd5)?din[23:20]:
            (s==3'd6)?din[27:24]:
            (s==3'd7)?din[31:28]:
            0;
   
   assign digit_nr= cnt;
   assign digit_value= d;
   
endmodule
