`include "vdefs.v"


module tm;

   reg resn= 0;
   reg clk= 0;
   reg clk1m= 0;
   reg rotup= 1;
   
   always #1 clk<= ~clk;
   always #4 clk1m<= ~clk1m;

   wire [31:0] PA;
   wire [31:0] PB;
   wire [31:0] PC;
   wire [31:0] PD;
   reg [31:0]  PI= 0;
   reg [31:0]  PJ= 0;
   
   comp test_computer
     (
      .CLK	(clk),
      .RESETn	(resn),
      .BOOT_MODE(1'b0),
      .PA_P0    (PA),
      .PB_P0    (PB),
      .PC_P0    (PC),
      .PD_P0    (PD),
      .PI_P0    (PI),
      .PJ_P0    (PJ),
      .CLK_1M   (clk1m)
      );
   
   initial
     begin
	PI[3:0]= 4;
	PI[7:5]= 6;
	#2000 PJ= 10;
     end
   
   initial
     begin
	$dumpfile("tm.vcd");
	$dumpvars(0,PA,PB,PC,PD,PI,PJ);
	//$dumpvars();
	#13 resn= 1;
	#`CYCLES $finish();
     end
   
endmodule // tm
