PRJ		= .
CFG_DIR		= ..

board		= pro_v2
BOARD		= PRO_V2

DEFINES		= -DBOARD=BOARD_$(BOARD)
#-D_REENT_SMALL

APP		= brgy

all: dep brgy.0as brgy.1as brgy.2as brgy.3as $(APP)_dasm.txt $(APP).bin report

#SILENT		= no
-include $(PRJ)/common.mk

OBJ_OTHERS	= $(PRJ)/utils/utils.o \
		$(PRJ)/utils/print.o \
		$(PRJ)/utils/cutils.o \
		$(PRJ)/utils/utime.o \
		$(PRJ)/utils/terminal.o \
		$(PRJ)/driver/drv_sim.o \
		$(PRJ)/startup.o \
		$(PRJ)/system.o \
		$(PRJ)/cmsdk/cmsdk_uart.o

#$(PRJ)/driver/drv_uart.o \
#$(PRJ)/driver/fs.o \


SRC_APP		= $(APP).c

SRC_ALL		= $(SRC_APP)
OBJ_ALL		= $(SRC_ALL:.c=.o) $(OBJ_OTHERS)

LINK_CMD	= $(PRJ)/$(board).ld

MAKEFILES	= Makefile $(PRJ)/common.mk

$(APP).elf: $(OBJ_ALL) $(MAKEFILES) $(LINK_CMD)
ifeq ($(SILENT),yes)
	@echo LN $(APP)
	@$(CC) $(CFLAGS) $(OBJ_ALL) $(LDFLAGS) -lm -o $@
else
	$(CC) $(CFLAGS) $(OBJ_ALL) $(LDFLAGS) -lm -o $@
endif

$(APP).bin: $(APP).elf
	@$(OC) $(APP).elf -O binary $(APP).bin

$(APP)_dasm.txt: $(APP).elf
	@$(OD) -D -S -l $(APP).elf >$(APP)_dasm.txt

brgy.bin: $(APP).elf
	@@$(OBJCOPY) -O binary $< $@

dep: $(APP).dep

$(APP).dep: $(SRC_ALL) *.h $(MAKEFILES)
	@$(CC) -MM $(CPPFLAGS) $(SRC_ALL) >$@

report: $(APP).elf
	$(SIZE) $<


#	$(SIZE) --format=SYSV $<|report_ram_usage.sh -r 8192 -a $(APP) -s

-include $(APP).dep
-include $(CFG_DIR)/config.mk

clean:
	$(RM) *.o *.elf *.hex *.bin *.map *~ *.i $(SRC_ALL:.c=.s) *.lst *.dep *.d *.s *_dasm.txt *.dep *.0as *.1as *.2as *.3as
