#ifndef DEV_HEADER
#define DEV_HEADER

//#define DEBUG_STARTUP 1

#define SHARED __attribute__ ((section(".shared")))
#define SHARED_PRIVA __attribute__ ((section(".shared_priva")))
#define SHARED_PRIVB __attribute__ ((section(".shared_privb")))
#define OMEM __attribute__ ((section(".omem")))

#define __IO volatile

#define ALIGN __attribute__ (( aligned (4) ))

struct GPIO_OUT4_TYPE {
  __IO unsigned int pa;
  __IO unsigned int pb;
  __IO unsigned int pc;
  __IO unsigned int pd;
  __IO unsigned int print;
  __IO unsigned int simstop; // 0xdead1e0d
};

struct GPIO_PORT_TYPE {
  __IO unsigned int dr;
};

struct GPIO_PRINT_TYPE {
  __IO unsigned int dr;
};

struct GPIO_SIMSTOP_TYPE {
  __IO unsigned int dr;
};

struct GPIO_IN2_TYPE {
  __IO unsigned int reg0;
  __IO unsigned int reg1;
  __IO unsigned int reg2;
  __IO unsigned int reg3;
  __IO unsigned int pi;
  __IO unsigned int pj;
};

struct CMSDK_APB_TIMER {
  __IO unsigned int CTRL;
  __IO unsigned int VALUE;
  __IO unsigned int RELOAD;
  __IO unsigned int INTSTATUS;
};

struct CMSDK_APB_UART {
  __IO unsigned int DATA;
  __IO unsigned int STATE;
  __IO unsigned int CTRL;
  __IO unsigned int INTSTATUS;
  __IO unsigned int BAUDDIV;
};

struct WATCH_TYPE {
  __IO unsigned int CNT_L;
  __IO unsigned int CNT_H;
  __IO unsigned int BUF;
  __IO unsigned int STATUS;
  __IO unsigned int CTRL;
  __IO unsigned int PRE;
};

#define HSEL_S0 0x00000000   //MEMORY MAP --> 0x0000_0000 to 0x00FF_FFFF  16MB
#define HSEL_S1 0x50000000   //MEMORY MAP --> 0x5000_0000 to 0x50FF_FFFF  16MB	
#define HSEL_S2 0x51000000   //MEMORY MAP --> 0x5100_0000 to 0x51FF_FFFF  16MB
#define HSEL_S3 0x52000000   //MEMORY MAP --> 0x5200_0000 to 0x52FF_FFFF  16MB
#define HSEL_S4 0x53000000   //MEMORY MAP --> 0x5300_0000 to 0x53FF_FFFF  16MB
#define HSEL_S5 0x54000000   //MEMORY MAP --> 0x5400_0000 to 0x54FF_FFFF  16MB
#define HSEL_S6 0x55000000   //MEMORY MAP --> 0x5500_0000 to 0x55FF_FFFF  16MB
#define HSEL_S7 0x56000000   //MEMORY MAP --> 0x5600_0000 to 0x56FF_FFFF  16MB
#define HSEL_S8 0x57000000   //MEMORY MAP --> 0x5700_0000 to 0x57FF_FFFF  16MB
#define HSEL_S9 0x58000000   //MEMORY MAP --> 0x5800_0000 to 0x58FF_FFFF  16MB

#define HSEL_M4 0x40000000
#define HSEL_M8 0x80000000
#define HSEL_M9 0x90000000

#define HSEL_P0 0x50000000
#define HSEL_P1 0x51000000
#define HSEL_P2 0x52000000


typedef enum IRQn
  {
    NonMaskableInt_IRQn		= -14,
    HardFault_IRQn		= -13,
    SVCall_IRQn			= -5,
    PendSV_IRQn			= -2,
    SysTick_IRQn		= -1,
    /* Board specific interrupt numbers */
    /* 0-15 IRQs come from APB subsystem */
    UART0_RX_IRQn		= 0,
    UART0_TX_IRQn		= 1,
    UART1_RX_IRQn		= 2,
    UART1_TX_IRQn		= 3,
    UART2_RX_IRQn		= 4,
    UART2_TX_IRQn		= 5,
    Brd6_IRQn			= 6,
    Brd7_IRQn			= 7,
    TIMER0_IRQn			= 8,
    TIMER1_IRQn			= 9,
    TIMER2_IRQn			= 10,
    Brd11_IRQn			= 11,
    UART0_OVF_IRQn		= 12,
    UART1_OVF_IRQn		= 13,
    UART2_OVF_IRQn		= 14,
    Brd15_IRQn			= 15,
    
    Brd16_IRQn			= 16,
    Brd17_IRQn			= 17,
    Brd18_IRQn			= 18,
    Brd19_IRQn			= 19,
    Brd20_IRQn			= 20,
    Brd21_IRQn			= 21,
    Brd22_IRQn			= 22,
    Brd23_IRQn			= 23,
    Brd24_IRQn			= 24,
    Brd25_IRQn			= 25,
    Brd26_IRQn			= 26,
    Brd27_IRQn			= 27,
    Brd28_IRQn			= 28,
    Brd29_IRQn			= 29,
    Brd30_IRQn			= 30,
    Brd31_IRQn			= 31
  } IRQn_Type;

#define __NVIC_PRIO_BITS	2

#include "core_cm0.h"

//#if (BOARD & (BOARD_PRO_V2|BOARD_PRO_V3))
#define APB		0x60000000
#define OUT4		((struct GPIO_OUT4_TYPE *)(HSEL_P0))
#define TIMER0		((struct CMSDK_APB_TIMER *)(APB+0x0000))
#define UART0		((struct CMSDK_APB_UART  *)(APB+0x4000))
#define GPIOA		((struct GPIO_PORT_TYPE *)(HSEL_P0+0))
#define GPIOB		((struct GPIO_PORT_TYPE *)(HSEL_P0+4))
#define GPIOC		((struct GPIO_PORT_TYPE *)(HSEL_P0+8))
#define GPIOD		((struct GPIO_PORT_TYPE *)(HSEL_P0+12))
#define SIM_PRINTER	((struct GPIO_PRINT_TYPE *)(HSEL_P0+16))
#define SIMSTOP		((struct GPIO_SIMSTOP_TYPE *)(HSEL_P0+20))
#include "cmsdk_uart.h"
//#endif

//#if (BOARD & BOARD_PRO_V2)
#define WATCH		((struct WATCH_TYPE *)(HSEL_P1))
#define IN2		((struct GPIO_IN2_TYPE *)(HSEL_P2))
#define GPIOI		((struct GPIO_PORT_TYPE *)(HSEL_P2+16))
#define GPIOJ		((struct GPIO_PORT_TYPE *)(HSEL_P2+20))
//#endif

#define SPRINT		(SIM_PRINTER->dr)
#define PA		(GPIOA->dr)
#define PB		(GPIOB->dr)
#define PC		(GPIOC->dr)
#define PD		(GPIOD->dr)
#define PI		(GPIOI->dr)
#define PJ		(GPIOJ->dr)

#endif
