#ifndef DRV_UART_HEADER
#define DRV_UART_HEADER

#include "dev.h"


enum
  {
   nuof_uarts= 3,
   rbuf_size= 16,
   tbuf_size= 128
  };

struct dev_uart_t {
  int inited;
  struct CMSDK_APB_UART *UART;
  int RX_IRQn;
  int TX_IRQn;
  int rff;
  int rlu;
  int tff;
  int tlu;
  volatile unsigned int *avail;
  volatile unsigned int *sends;
  char rbuf[rbuf_size];
  char tbuf[tbuf_size];
};


extern int uart_init(int unr);
extern int uart_close(int unr);
extern int uart_write(int unr, char *buf, int len);
extern unsigned int uart_avail(int unr);
extern unsigned char uart_receive(int unr);


#endif
