#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdint.h>
#include <errno.h>

#include "fs.h"

#include "drv_uart.h"
#include "print.h"


char *heap_end;

caddr_t
_sbrk(int incr)
{
  extern char _end;             // Defined by the linker
  extern char _eram;
  char *prev_heap_end;

  if (heap_end == 0) {
    heap_end = &_end;
  }
  prev_heap_end = heap_end;
  if (heap_end + incr > &_eram //stack_ptr
      )
    {
      write (1, "Heap and stack collision\n", 25);
      while (1) ;
    }

  heap_end += incr;
  return (caddr_t) prev_heap_end;

  return NULL;
}

void
print_mem_info()
{
  extern char _end;             // Defined by the linker
  extern char _eram;
  print_f("%p %p %p\n", &_end, heap_end, &_eram);
}

int
_open(const char *fn, int fl, int m)
{
  return -1;//fs_open(fn, fl, m);
}

int
_write(int file, char *ptr, int len)
{
  int i= 0;
  while (len--)
    {
      PC= len;
      SPRINT= ptr[i++];
    }
  //uart_write(0, ptr, len);
  
  return i;
}

int
_close(int file)
{
  return 0;//fs_close(file);
}

int
_read(int file, char *ptr, int len)
{
  /*int i= 0;
  while (len--)
    {
      while (!uart_avail(0)) ;
      ptr[i++]= uart_receive(0);
      }*/
  return 0;//i;
}

int
_lseek(int file, int ptr, int dir)
{
  return -1;
}

int
_isatty(int fd)
{
  return 1;
}

int
_fstat(int fd, struct stat *statbuf)
{
  return -1;
}

int
_gettimeofday(struct timeval *TP, void *TZP)
{
  uint64_t ll= 0;
  uint32_t h, l;
  if (TP)
    {
      WATCH->BUF= 1;
      l= WATCH->CNT_L;
      h= WATCH->CNT_H;
      ll= (h * UINT64_C(0x100000000) + l);
      TP->tv_sec = ll / 1000000;
      TP->tv_usec= ll % 1000000;
    }
  return 0;
}

int
settimeofday(const struct timeval *TP, const struct timezone *TZP)
{
  if (TP)
    {
      uint64_t t= ((uint64_t)(TP->tv_sec))*1000000 + (uint64_t)(TP->tv_usec);
      uint32_t h, l;
      h= t / UINT64_C(0x100000000);
      l= t & 0xffffffff;
      WATCH->CTRL= 0;
      WATCH->CNT_L= l;
      WATCH->CNT_H= h;
      WATCH->CTRL= 1;
    }
  return 0;
}

void
_exit(int Code)
{
  for (;;);
}

int
_kill(int pid, int sig)
{
  errno= EINVAL;
  return -1;
}

int
_getpid(void)
{
  return 1;
}
