/*
 * cutils.c
 *
 * (C) Drtos Dniel
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "utils.h"

#include "cutils.h"


/******************************************************************* STRING */

/* Parse: string to bin */

/* 1 char -> bin (radix 16) */
/*
int
hex2bin(char c)
{
  if (c>='0' && c<='9')
    return c-'0';
  if (c>='a' && c<='f')
    return c-'a'+10;
  if (c>='A' && c<='F')
    return c-'A'+10;
  return 0;
}
*/
int
str1_bin16(char c)
{
  return hex2bin(c);
}

/* 2 char -> bin (radix 16) */

unsigned char
get_ascii_byte(char *msg, int pos)
{
  return 16*hex2bin(msg[pos]) + hex2bin(msg[pos+1]);
}

unsigned char
str2_bin16(char *msg, int pos)
{
  return get_ascii_byte(msg, pos);
}

/* 2 char -> bin (radix 10) */

unsigned char
str2_bin10(char *msg, int pos)
{
  return 10*(msg[pos]-'0')+(msg[pos+1]-'0');
}

/* 4 char -> bin (radix 16) */

unsigned int
get_ascii_word(char *msg, int pos)
{
  return get_ascii_byte(msg, pos)*256 + get_ascii_byte(msg, pos+2);
}

unsigned int
str4_bin16(char *msg, int pos)
{
  return get_ascii_word(msg, pos);
}

/* 4 char -> bin (radix 10) */

unsigned int
str4_bin10(char *msg, int pos)
{
  return 100*str2_bin10(msg, pos) + str2_bin10(msg, pos+2);
}


/* Format bin to string */

/* bin -> 2 char (radix 16) */

static char b2h_buffer[3];

char *
byte2hex(int data)
{
  char *c1= "0123456789";
  char *c2= "ABCDEF";
  int d;

  data&= 0xff;
  d= (data&0xf0)>>4;
  if (d<10)
    b2h_buffer[0]= c1[d];
  else
    b2h_buffer[0]= c2[d-10];
  d= data&0xf;
  if (d<10)
    b2h_buffer[1]= c1[d];
  else
    b2h_buffer[1]= c2[d-10];
  b2h_buffer[2]= '\0';
  return b2h_buffer;
}

char *
bin16_str2(int data)
{
  return byte2hex(data);
}

/* bin -> 4 char (radix 16) */

static char w2h_buffer[3];

char *
word2hex(int data)
{
  w2h_buffer[0]= '\0';
  strcpy(w2h_buffer, byte2hex((data&0xff00)>>8));
  strcat(w2h_buffer, byte2hex(data&0xff));
  return w2h_buffer;
}

char *
bin16_str4(int data)
{
  return word2hex(data);
}

/* bin32 -> 32 char (radix 2) */

static char i2b_buffer[33];

char *
bin32_str32(unsigned int data)
{
  int i;
  unsigned int m;
  for (i=0, m=0x80000000; i < 32; i++, m>>=1)
    i2b_buffer[i]= (data&m)?'1':'0';
  i2b_buffer[32]= '\0';
  return i2b_buffer;
}


int
enum_value(char *value, const char *value_names[])
{
  int i;
  for (i= 0; value_names[i]; i++)
    if (strcmp(value, value_names[i]) == 0)
      return i;
  return 0;
}


const char *
enum_name(int enum_value, const char *enum_names[])
{
  int i;
  for (i= 0; enum_names[i]; i++)
    if (enum_value==i)
      return enum_names[i];
  return "unknown";
}


/********************************************************************* MATH */

double
deg2rad(double deg)
{
  return deg*PI/180.0;
}

double
rad2deg(double rad)
{
  return rad*180.0/PI;
}

double
mod(double a, double b)
{
  long long int l;
  l= a/b;
  return a-l*b;
}

char
sign_of_float(float x)
{
  return (x<0)?'-':'+';
}

long
integer_of_float(float x)
{
  //long l= (long)x;
  return (x<0)?-x:x;
}

int
fractional_of_float(float x)
{
  int i= (int)((x - (long)x)*10000);
  return (i<0)?-i:i;
}

char
sign_of_double(double x)
{
  return (x<0)?'-':'+';
}

long
integer_of_double(double x)
{
  //long l= (long)x;
  return (x<0)?-x:x;
}

int
fractional_of_double(double x)
{
  int i= (int)((x - (long)x)*10000);
  return (i<0)?-i:i;
}

char *
string_of_double(double x)
{
  //long l;
  //int i;
  static char buf[100];
  snprintf(buf, 99, "%c%ld.%04d", SD(x), ID(x), FD(x));
  return buf;
}

double
dmax(double d1, double d2)
{
  return (d1>d2)?d1:d2;
}

double
dmin(double d1, double d2)
{
  return (d1<d2)?d1:d2;
}

int
imax(int d1, int d2)
{
  return (d1>d2)?d1:d2;
}

int
imin(int d1, int d2)
{
  return (d1<d2)?d1:d2;
}


/* End of cutils.c */
