#include <stdarg.h>
#include <unistd.h>

//#include "drv_uart.h"
#include "drv_sim.h"

#include "print.h"


char printc(char c)
{
  //if (!SPRINT) uart_write(0, &c, 1);
  SPRINT= c;
  return c;
}


void
print(char *s)
{
  if (!s)
    s= "(null)";
  for (; *s; printc(*s++)) ;
}


void
print_f(char *s, ...)
{
  va_list ap;
  int i;
  unsigned int u;
  //float f;
  double d;
  void *p;
  
  if (!s || !*s)
    return;
  
  va_start(ap, s);

  for (; *s; s++)
    {
      if (*s == '%')
	{
	  s++;
	  if (*s)
	    {
	      switch (*s)
		{
		case '%': printc(*s); break;
		case 'd':
		  i= va_arg(ap, int);
		  print_d(i);
		  break;
		case 'u':
		  u= va_arg(ap, unsigned int);
		  print_u(u);
		  break;
		case '2':
		  u= va_arg(ap, unsigned int);
		  print_cx(u);
		  break;
		case '4':
		  u= va_arg(ap, unsigned int);
		  print_4x(u);
		  break;
		case 'x': case '8':
		  u= va_arg(ap, unsigned int);
		  print_8x(u);
		  break;
		case 'p':
		  p= va_arg(ap, void*);
		  print_p(p);
		  break;
		case 'c':
		  u= va_arg(ap, unsigned int);
		  print_c(u);
		  break;
		case 's':
		  p= va_arg(ap, void*);
		  print((char*)p);
		  break;
		case 'f':
		  d= va_arg(ap, double);
		  print_D(d);
		  break;
		case 'F':
		  d= va_arg(ap, double);
		  print_D(d);
		  break;
		default:
		  i= va_arg(ap, int);
		  print_c(*s);
		  break;
		}
	    }
	}
      else
	printc(*s);
    }
  va_end(ap);
}

/* float and double */

void
print_fl(float f)
{
  int i= f;
  print_d(i);
  f= (f - i) * 10000;
  i= f+0.5;
  if (i < 0)
    i= -i;
  if (i)
    {
      print_c('.');
      print_d(i);
    }
}


void
print_D(double f)
{
  int i= f;
  print_d(i);
  f= (f - i) * 10000;
  i= f+0.5;
  if (i < 0)
    i= -i;
  if (i)
    {
      print_c('.');
      print_d(i);
    }
}


/* signed integer in decimal */

void
print_d(int i)
{
  int x= 1000000000;
  int in= 0;
  if (i<0)
    {
      printc('-');
      i= -i;
    }
  while (x)
    {
      int j= i/x;
      if (in || j || (x==1))
	printc(j+'0');
      in= in || j;
      i%= x;
      x/= 10;
    }
}


/* unsigned integer in decimal */

void
print_u(unsigned int i)
{
  int x= 1000000000;
  int in= 0;
  while (x)
    {
      int j= i/x;
      if (in || j || (x==1))
	printc(j+'0');
      in= in || j;
      i%= x;
      x/= 10;
    }
}


/* unsigned int in hex */

void
print_cx(unsigned char i)
{
  printc((i/16)+(((i/16)<10)?'0':('A'-10)));
  printc((i&15)+(((i&15)<10)?'0':('A'-10)));
}

void
print_4x(unsigned int i)
{
/*
  unsigned char j;
  for (j= 0; j<4; j++)
    {
      char v= (i&0xf000)>>12;
      printc(v+((v<10)?'0':('A'-10)));
      i<<= 4;
    }
*/
  print_cx(i/256);
  print_cx(i&0xff);
}

void
print_8x(unsigned int i)
{
  print_4x(i/0x10000);
  print_4x(i&0xffff);
}

void
print_p(void *p)
{
  unsigned int u= (unsigned int)p;
  print_8x(u);
}

void
print_c(char c)
{
  //printc(c);
  write(1, &c,1);
}
