#include "terminal.h"


void
tu_save_cursor()
{
  print("\033[s");
  //fflush(stdout);
}


void
tu_restore_cursor()
{
  print("\033[u");
  //fflush(stdout);
}

void
tu_go_left(int n)
{
  print_f("\033[%dD", n);
  //fflush(stdout);
}

void
tu_go_right(int n)
{
  print_f("\033[%dC", n);
  //fflush(stdout);
}

void
tu_go_up(int n)
{
  print_f("\033[%dA", n);
  //fflush(stdout);
}

void
tu_go_down(int n)
{
  print_f("\033[%dB", n);
  //fflush(stdout);
}

void
tu_go(int x1, int y1)
{
  print_f("\033[%d;%dH", y1, x1);
  //fflush(stdout);
}

void
tu_clear_screen()
{
  print("\033[2J");
  tu_go(1, 1);
  //fflush(stdout);
}

void
tu_clear_char()
{
  tu_save_cursor();
  print_c(' ');
  tu_restore_cursor();
}

static int tu_bg_color, tu_fg_color;

void
tu_color(int bg, int fg)
{
  if (bg >= 0)
    print_f("\033[%dm", (tu_bg_color= bg)+40);
  if (fg >= 0)
    print_f("\033[%dm", (tu_fg_color= fg)+30);
  //fflush(stdout);
}

void
tu_hide(void)
{
  print("\033[?25l");
  //fflush(stdout);
}

void
tu_show(void)
{
  print("\033[?25h");
  //fflush(stdout);
}
