#include "print.h"

#include "utils.h"

int
is_alpha(char c)
{
  return
    (
     (c>='a') && (c<='z')
     ) ||
    (
     (c>='A') && (c>='Z')
     );
}

int
is_print(char c)
{
  return ((c > 31) && (c < 128));
}

// A 41 0100 0001
// a 61 0110 0001
int
hex2bin(char c)
{
  c|= 0x20;
  if ((c >= '0') && (c <= '9'))
    return c - '0';
  else if ((c >= 'a') && (c <= 'f'))
    return 10 + c - 'a';
  return 0;
}

unsigned int
str_tox(char *s)
{
  //int neg= 0;
  unsigned int l= 0;
  if ((s == 0) || (*s == 0))
    return 0;
  while ((*s == ' ') && *s)
    s++;
  if (!*s)
    return l;
  /*if (*s == '+')
    (neg= 0), s++;
  if (*s == '-')
  (neg= 1), s++;*/
  while (*s)
    {
      int i= hex2bin(*s);
      l<<= 4;
      l|= (i&0xf);
      s++;
    }
  //if (neg)
  //l= -l;
  return l;
}

int
str_tol(char *s)
{
  int neg= 0;
  int rad= 0;
  int l= 0;
  if ((s == 0) || (*s == 0))
    return 0;
  while ((*s == ' ') && *s)
    s++;
  if (!*s)
    return 0;
  if ((*s == '+') ||
      (*s == '-'))
    {
      if (*s == '-')
	neg= 1;
      s++;
    }
  if (!*s)
    return 0;
  while (*s)
    {
      if (!rad)
	{
	  if (*s == '0')
	    rad= 8;
	  if (*s > '0')
	    rad= 10;
	}
      if (rad)
	{
	  int i;
	  if ((rad==8) && ((*s == 'x') || (*s == 'X')))
	    {
	      rad= 16;
	      s++;
	      continue;
	    }
	  if (rad == 16)
	    i= hex2bin(*s);
	  else
	    i= *s - '0';
	  if (i >= rad)
	    i= rad-1;
	  l*= rad;
	  l+= i;
	}
      s++;
    }
  return (neg)?-l:l;
}

int
str_len(char *s)
{
  int l= 0;
  if (!s)
    return 0;
  while (*s++)
    l++;
  return l;
}

char *
str_chr(char *s, char c)
{
  if (!s)
    return 0;
  while (*s != c)
    {
      if (!*s)
	return 0;
      s++;
    }
  return s;
}

int
str_spn(char *s, char *accept)
{
  int i;
  if (!s)
    return 0;
  i= 0;
  while (s[i] && (str_chr(accept, s[i])!=0))
    i++;
  return i;
}

int
str_cspn(char *s, char *reject)
{
  int i;
  if (!s)
    return 0;
  i= 0;
  while (s[i] && (str_chr(reject, s[i])==0))
    i++;
  return i;
}

static char *s_start;
static int s_len;
static int s_pars_pos;

char *
str_tok(char *s, char *delims)
{
  int l;
  char *c= 0;
    
  if (str_len(delims) < 1)
    return 0;
  if (s != (char*)0)
    {
      s_start= s;
      s_len= str_len(s);
      s_pars_pos= 0;
    }
  // skip initial delims first
  l= str_spn(&s_start[s_pars_pos], delims);
  s_pars_pos+= l;
  if (s_pars_pos >= s_len)
    return (char*)0;
  c= &s_start[s_pars_pos];
  // skip chars not in delims: search token end
  l= str_cspn(&s_start[s_pars_pos], delims);
  s_pars_pos+= l;
  s_start[s_pars_pos]= 0;
  s_pars_pos++;
  
  return c;
}

int
str_cmp(char *p1, char *p2)
{
  unsigned char *s1 = (unsigned char *) p1;
  unsigned char *s2 = (unsigned char *) p2;
  unsigned char c1, c2;
  do
    {
      c1 = (unsigned char) *s1++;
      c2 = (unsigned char) *s2++;
      if (c1 == '\0')
        return c1 - c2;
    }
  while (c1 == c2);
  return c1 - c2;
}
